
__no_init
struct
{
 u8 init;          

 u16 Vref;
 u16 u_tcp;
 u16 LM358_offset;
 u32 R1;
 u32 R2;
} eep @ 0x4000;


class periph_init
{
 public:
 void gpio()
 {
  PA_ODR = 0;
  PA_CR1 = 0xff;
  PA_DDR = 0;

  PB_CR1 = 1<<7|1<<6;
  PB_ODR = 0;
  PB_DDR = 0xff-(1<<7|1<<6|1<<1|1);

  PC_CR1 = 0xff;
  PC_ODR = 0xff-(1<<4|1<<3|1<<2|1<<1);
  PC_DDR = 0xff;

  PD_CR1 = 0xff;
  PD_ODR = 0xff;
  PD_DDR = 0xff-2;

  PE_CR1 = 0xff;
  PE_ODR = 0;
  PE_DDR = 0xff;

  PF_CR1 = 0xff;
  PF_ODR = 0;
  PF_DDR = 0xff;
 }
 void clk()
 {
  CLK->CKDIVR = 0;    
  CLK->PCKENR1 = CLK_PCKENR1_TIM4;
  CLK->PCKENR2 = CLK_PCKENR2_ADC|CLK_PCKENR2_AWU;
 }
 void t4()   //1000Hz
 {
   TIM4->ARR   = (u32)16E6/128/1000-1;
   TIM4->PSCR  = 7;
   TIM4->IER   = 1; 
   TIM4->CR1   = 1;
 }
 void adc()
 {
  ADC1->CSR  = 1;  
  ADC1->CR1  = ADC1_PRESSEL_FCPU_D18|ADC1_CR1_ADON;
  ADC1->CR2  = ADC1_ALIGN_RIGHT|ADC1_CR2_SCAN;
  ADC1->CR3  = ADC1_CR3_DBUF;
  ADC1->TDRL = 3;
 } 
 void iwdg()
 {
  IWDG_Enable();
  IWDG_WriteAccessCmd(IWDG_WriteAccess_Enable);
  IWDG_SetPrescaler(IWDG_Prescaler_256);
  IWDG_SetReload(0xff);
  IWDG_ReloadCounter();
 }
 void ee()
 {
  #define initval 0x1d
  if(eep.init!=initval)
  {
   FLASH_Unlock(FLASH_MEMTYPE_DATA);
   eep.init = initval;
   
   eep.Vref  = 1820;
   eep.u_tcp = 41;
   eep.R1    = 3300;
   eep.R2    = 510E3;
   eep.LM358_offset = 100; //mV
   
   FLASH_Lock(FLASH_MEMTYPE_DATA);
  }
 }
}cfg;

