
volatile bool adc_ready;
volatile u16 ref_retval;
volatile u16 tin_retval;
volatile u8 adc_tim;

bool read_adc(u16 *retval)
{
 static bool trg=0;
 static bool scr_tmp;
 
 if(!trg)
 {
  trg=1;
  if(scr_state)
  {
   scr_tmp=1;
   scr_off;   
  }
  else scr_tmp =0;

  adc_tim = 11;
 }
  
 if(!adc_tim)
 {
  static bool trg2=0;
  
  if(!trg2)
  {
   trg2=1;
   adc_ready = 0;
  }
  else if(adc_ready)
  {
   trg2=0;
   trg =0;
   if(scr_tmp)scr_on;   
   
   u32 Vps = ((u32)eep.Vref<<10)/ref_retval;
   u16 tmp = Vps*tin_retval>>10;
   
   if(tmp > eep.LM358_offset) tmp -= eep.LM358_offset;
   else tmp = 0;
   
   *retval = tmp;
   
   return 1;
  }
 }
 
 return 0;
}